/*
		LLC - link log converter(^^;

		for LSI-C/MS-DOS, GCC/linux(intel)

*/

#ifdef JACK_PATCH
static char rcsid[] = "$Id: llc.c,v 1.5 1995/01/17 12:16:46 JACK Exp $";

#include <stdarg.h>
#if defined (__mc68000__) && defined (HUMAN68K)
#define __LSIC__ 0
#else
#define __LSIC__ 1
#endif
#else /* ! JACK_PATCH */
/* if 68 set 0 */
#define __LSIC__ 1
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/* 0.40 */
#if __LSIC__
#include <dos.h>
#include <farstr.h>
#ifdef JACK_PATCH
#define CALLOC farcalloc
#endif
#define	MALLOC			farmalloc
#define	FREE			farfree
#define   MEMCPY2N(x,y,i)	far_memcpy(MK_FP(bss,&x),y,i)
#define   MEMCPY2F(x,y,i)	far_memcpy(x,MK_FP(bss,&y),i)
#define	FAR				far
#else
#if __TSC__
#include <dos.h>
#include <io.h>
#include <alloc.h>
#ifdef JACK_PATCH
#define CALLOC _fcalloc
#endif
#define						MALLOC	_fmalloc
#define						FREE	_ffree
#define		MEMCPY2N(x,y,i)	_fmemcpy(MK_FP(bss,&x),y,i)
#define		MEMCPY2F(x,y,i)	_fmemcpy(x,MK_FP(bss,&y),i)
#define						FAR		far
#else
/* for flat memory model, like 68000 */
#include <unistd.h>
#ifdef JACK_PATCH
#define CALLOC calloc
#endif
#define					MALLOC	malloc
#define					FREE	free
#define	MEMCPY2F(x,y,i)	memcpy(x,y,i)
#define	MEMCPY2N(x,y,i)	memcpy(x,y,i)
#define					FAR
#endif
#endif

#define		READ_BUFFER_SIZE		(16384)		/* Disk Read Buffer Size
												   <32768  0.30E    */
#define		MAX_LINE_LENGTH 		(16384)		/* Ps̒
												   .30E	  */
#define		MAX_TITLE_LINE_LENGTH 	(90)		/* ȯċyMSGLINKtق
												   Ps̒ */
#define		MAX_TITLE_LINE_NUM		(10)		/* ȯċyMSGLINKtق
												   ős   */
#define		MAXXFER					 (5)		/* ȯݸĂȯĐ(
												   ȯĊ܂)   */
#define		MAXMES					(16384)		/* őL
												   0.40     */
 /* ȯݸœ]Ă݂̂̂̐     */

/* s̕2 */
#define		EOL0					(0x0d)		/* CR */
#define		EOL						(0x0a)		/* LF */

#define		TRUE					(1)	/* ^ */
#define		FALSE					(0)	/* U */

char *copyright = "LLC - Copyright RADD and fnk";
char *ver = "0.42";				/* ްޮݕ\Lp   */
#ifdef JACK_PATCH
char *verx = "0.02j";
#else
char *verx = "0.02";			/* ްޮݕ\Lp   */
#endif

FILE *oldlog;					/* ϊ̧ٽذ */
FILE *newlog;					/* ϊ̧ٽذ */

short open_log = 0;
short open_cfg = 0;


long oldsize;					/* ϊُ̧  */
unsigned char readbuff[READ_BUFFER_SIZE];		/* 1s擾ر      */

/* ǂݍł1s */
unsigned char line[MAX_LINE_LENGTH];
/* wb_ۑp̃obt@ */
unsigned char linesave[MAX_TITLE_LINE_NUM][MAX_TITLE_LINE_LENGTH];

short fileend = FALSE;
short debug = TRUE;
short messtat;

long FAR *ownserial;			/* 0.30E ̃lbgł̃VAwb_f[^ */
long FAR *message_num[MAXXFER];	/* elbgł̃bZ[Wԍ */
short FAR *origin_net;			/* 0.30E ܂ꂽlbg */

short wrap = FALSE;				/* 0.40 obt@ꏄ */
short linknum = 0;
short oldlinknum = 0;
short tidx;

short netxfer = 3;				/* ]Ălbg̏l */
short mesmax = 6400;			/* 郁bZ[W̍ő */

unsigned char net[MAXXFER][10];

unsigned char border1[20];
unsigned char border2[20];
unsigned char border3[100];

unsigned char bltitle[20];
unsigned char xfertitle[20];
unsigned char response[20];

/* IDėp{ԍ mod 0.40 */
long st_no[MAXXFER - 1];

/* ȯݸSID */
unsigned char blinkid[20];
unsigned char net_header[20];

/* رͯތ */
unsigned short shead_num = 0;

/* үޗ} 0.30D */
short disp_mes = FALSE;
short idmod = FALSE;

#if      __LSIC__ || __TSC__ || __TURBOC__
short bss;						/* data segmanet */
#ifdef JACK_PATCH
struct SREGS sregs;
#else
struct SREGS *sregs;
#endif
#endif

#ifdef JACK_PATCH
char *progname;
#endif

/* ߐ錾 */
short init_proc (char *dat);	/* get stored data */
short store (char *dat);
short get_cfg (char *cfg);
short procline (void);
void readline (FILE * fp);		/* 0.40 */
unsigned char readchar (FILE * fp);		/* 0.30E */
void makehead (unsigned char *l1, long i);
void makeres (unsigned char *l1, unsigned char *l2, long bnum);
long getnum (unsigned char *l1, char sep);
long searchorigin (short net, long bnum);
short searchchar (unsigned char *l1, char sep);
short get_pam (char *dst_str, char *src_str);
void helpdisp (char *name, char *mes);
void mod_name (char *nam, char *no_ext, char *ext);
long getsize (FILE * fp);
short readdat (FILE * fp, char FAR * buff, unsigned sizes);
short writedat (FILE * fp, char FAR * buff, unsigned sizes);
void fclose_all (void);
void exit_free (void);
#ifdef JACK_PATCH
char *get_basename (char *);
char *suppress_extension (char *);
char *get_rcfile (char *, char **, char *);
char *set_datfile (char *, char *, char *);
char *set_datpath (char *, char *);
void warning (char *, ...);
void fatal (char *, ...);
#endif

#ifdef JACK_PATCH
char *
get_basename (char *fname)
{
  char *p;

  if ((p = strrchr (fname, ':')) != NULL)
	fname = p + 1;
  if ((p = strrchr (fname, '/')) != NULL)
	fname = p + 1;
  if ((p = strrchr (fname, '\\')) != NULL)
	fname = p + 1;
  return fname;
}
#ifndef __MSDOS__
char *
suppress_extension (char *fname)
{
  int len;

  if ((len = strlen (fname)) > 2)
	if (fname[len - 2] == '.')
	  switch (fname[len - 1])
		{
		case 'x': case 'X':
		case 'r': case 'R':
		case 'z': case 'Z':
		  fname[len - 2] = '\0';
		  break;
		}
  return fname;
}
#else
char *
suppress_extension (char *fname)
{
  int len;

  if ((len = strlen (fname)) > 4)
	if (fname[len - 4] == '.')
	  if ((! stricmp (fname + len - 3, "EXE"))
		   || (! stricmp (fname + len - 3, "COM")))
		fname[len - 4] = '\0';
  return fname;
}
#endif /* __MSDOS__ */
char *
get_rcfile (char *rcfile, char **files, char *env)
{
  int i;
  char *p;

  if (files == NULL)
	return NULL;

  for (i = 0; files[i] != NULL; i++)
	{
	  /* JgT[` */
#ifndef __MSDOS__
	  strcpy (rcfile, "./");
#else
	  strcpy (rcfile, ".\\");
#endif
	  strcat (rcfile, files[i]);
	  if (access (rcfile, 0) == 0)
		return rcfile;

	  /* z[T[` */
	  if ((p = getenv ("HOME")) != NULL)
		{
		  strcpy (rcfile, p);
#ifndef __MSDOS__
		  strcat (rcfile, "/");
#else
		  strcat (rcfile, "\\");
#endif
		  strcat (rcfile, files[i]);
		  if (access (rcfile, 0) == 0)
			return rcfile;
		}
	}

  /* ϐT[` */
  if (env && (p = getenv (env)) != NULL)
	{
	  strcpy (rcfile, p);
	  if (access (rcfile, 0) == 0)
		return rcfile;
	}

  return NULL;
}

char *
set_datfile (char *datfile, char *basename, char *env)
{
  char *p;

  if ((p = getenv (env)) != NULL)
	strcpy (datfile, p);
  else if ((p = getenv ("HOME")) != NULL)
#ifndef __MSDOS__
	sprintf (datfile, "%s/%s.%s", p, basename,
			 (islower (basename[0]) ? "dat" : "DAT"));
#else
	sprintf (datfile, "%s\\%s.%s", p, basename,
			 (islower (basename[0]) ? "dat" : "DAT"));
#endif
  else
	sprintf (datfile, "%s.%s", basename,
			 (islower (basename[0]) ? "dat" : "DAT"));

  return datfile;
}

char *
set_datpath (char *datpath, char *datfile)
{
  char *p = datfile;
  char *q = get_basename (datfile);
  size_t size = q - p;

  if (size == 0)
	strcpy (datpath, "");
  else
	{
	  char *r;

	  strncpy (datpath, p, size);
	  datpath[size] = '\0';

	  /* [gfBNgȊO͍ŏIf~^ */
	  q = r = datpath;
	  if ((p = strrchr (q, ':')) != NULL)
	    q = r = p + 1;
	  if ((p = strrchr (q, '/')) != NULL)
	    q = p + 1;
	  if ((p = strrchr (q, '\\')) != NULL)
	    q = p + 1;
	  /* f~^ && [gȊO */
	  if (q != r && q - 1 != r)
	    q[-1] = '\0';
	}

	return datpath;
}

void
warning (char *format, ...)
{
  va_list ap;

  va_start (ap, format);
  fprintf (stdout, "%s: warning: ", progname);
  vfprintf (stdout, format, ap);
  va_end (ap);
  fprintf (stdout, "\n");
  fflush (stdout);
}

void
fatal (char *format, ...)
{
  va_list ap;

  va_start (ap, format);
  fprintf (stderr, "%s: ", progname);
  vfprintf (stderr, format, ap);
  va_end (ap);
  fprintf (stderr, "\n");
  fflush (stderr);
  exit (1);
}
#endif

int
main (int argc, char *argv[])
{
#ifdef JACK_PATCH
  char oldname[FILENAME_MAX];
  char newname[FILENAME_MAX];
  char bakname[FILENAME_MAX];
  char datpath[FILENAME_MAX];
  char cfgname[FILENAME_MAX];
  char datname[FILENAME_MAX];
  char oldfil[FILENAME_MAX];
  char *llccnf_files[] = 
	{
#ifndef __MSDOS__
	  ".llcrc",
	  "_llcrc",
	  "llc.cnf",
	  "llc.cfg",
#endif
	  "_LLCRC",
	  "LLC.CNF",
	  "LLC.CFG",
	  NULL,
	};
  char *llcdat_files[] = 
	{
#ifndef __MSDOS__
	  ".llcdat",
	  "_llcdat",
	  "llc.dat",
#endif
	  "_LLCDAT",
	  "LLC.DAT",
	  NULL,
	};
#else
  char oldname[40];				/* ϊ̧ٖ */
  char newname[40];				/* ϊ̧ٖ */
  char bakname[40];				/* ޯ̧ٖ */
  char datpath[256];			/* ް̧߽ 0.40 */
  char cfgname[256];			/* config file 0.40 */
  char datname[256];			/* save file 0.40 */
  char oldfil[40];
#endif
  short i, argidx, linkdiff;	/* 0.40 */
  short sts_cfg;
  char wk_ch[256];
  char wk_dnam[256];

#ifdef JACK_PATCH
  /* HUPAIRł͋NpX݂͑Ȃ(ȊO) */
  /* strip directory */
  progname = get_basename (argv[0]);
  (void) suppress_extension (progname);

  argv[0] = progname;
#endif

#if  __LSIC__ || __TURBOC__ || __TSC__
  fprintf (stderr, "Link Log Converter -LLC- V%s\n", ver);
#else
  fprintf (stderr, "Link Log Converter -LLC- for X68 Ver%s\n", verx);
  fprintf (stderr, "         Base Version is LLC for MS-DOS Ver.%s \n\n", ver);
#endif

#if  __LSIC__ || __TSC__ || __TURBOC__
  /* get near data segment */
#ifdef JACK_PATCH
  segread (&sregs);
  bss = sregs.ds;
#else
  segread (sregs);
  bss = sregs->ds;
#endif
#endif

  oldname[0] = '\0';

#ifdef JACK_PATCH
  if (get_rcfile (cfgname, llccnf_files, "LLCRC") == NULL)
	fatal ("rcfile not found.");

  if (get_rcfile (datname, llcdat_files, "LLCDAT") == NULL)
	{
	  (void) set_datfile (datname, argv[0], "LLCDAT");
	  warning ("datfile not found.");
	  warning ("default datfile \"%s\".", datname);
	}

  (void) set_datpath (datpath, datname);
#else
  /* ̫Ē`̧ٖ쐬 */
  /* şٖ`̧ٖɂȂ */
  strcpy (wk_ch, argv[0]);
  for ((i = strlen (wk_ch) - 1); i > 0; i--)
	{
	  if (wk_ch[i] == '.')
		{
		  break;
		}
	}
  wk_ch[i] = '\0';
  sprintf (cfgname, "%s", wk_ch);
  strcat (cfgname, ".cfg");

  /* ް̧ٖ쐬 */
  /* ş̧ٖٖɂȂ */
  sprintf (datname, "%s", wk_ch);
  strcat (datname, ".dat");

  /* ް߽擾 */
  i--;
  for (; i > 0; i--)
	{
	  if (wk_ch[i] == '\\')
		{
		  break;
		}
	}
  wk_ch[i] = '\0';
  strcpy (datpath, wk_ch);
#endif /* JACK_PATCH */

  /* Ұ */
  argidx = 0;
  while (argc > (++argidx))
	{
#if 0
	  fprintf (stderr, "  arg %hd is %s %c\n", argidx,
			   argv[argidx],
			   argv[argidx][0]
		);
#endif
	  if ((argv[argidx][0] == '-') || (argv[argidx][0] == '/'))
		{
		  /* ڰL */
		  if (strlen (argv[argidx]) <= 1)
			{
			  /* g(^^; */
			  continue;
			}
		  /* 啶 */
		  switch (toupper (argv[argidx][1]))
			{
			case 'D':
			  {
				/* debug mode, be verbose */
				disp_mes = TRUE;
				break;
			  }
			case 'F':
			  {
				/* cfg and dat file name */
				strcpy (wk_ch, &argv[argidx][2]);
				mod_name (wk_ch, wk_dnam, ".cfg");
				/* `̧ٖ */
				sprintf (cfgname, "%s\\%s", datpath, wk_ch);
				/* ̧ٖ */
				sprintf (datname, "%s\\%s", datpath, wk_dnam);
				strcat (datname, ".dat");
				break;
			  }
			default:
			  {
				sprintf (wk_ch, "  ȃIvVmȂ (T-T) > %s\n", argv[argidx]);
				helpdisp (argv[0], wk_ch);
				printf ("bZ[WZ[ut@C̕shׂɏI܂\n");
				exit (-1);
			  }
			}
		}
	  else
		{
		  /* ۸̧ٖ쐬 */
		  strcpy (oldname, argv[argidx]);
		  mod_name (oldname, oldfil, ".log");
		  /* ޯ̧ٖ쐬 */
		  for (i = 0; i < 1000; i++)
			{
			  sprintf (wk_ch, "%s.%03d", oldfil, i);
			  if (access (wk_ch, 0) != 0)
				{
				  /* ̧ق͖ ׯ! */
				  break;
				}
			  if (i >= 1000)
				{
				  /* \gqI[o */
				  fprintf (stderr, "obNAbvt@CȂ((((((( T-T)\n");
				  exit (-1);
				}
			}
		  strcpy (bakname, wk_ch);
		}
	}
  if (oldname[0] == '\0')
	{
	  /* ۸̧ٖw薳 (T-T  */
	  helpdisp (argv[0], "  LOG name undefine");
	  exit (-1);
	}

  /* ̧ٖ */
  sprintf (newname, "%s.$$$", oldfil);

  fileend = FALSE;
  /* `َ̧擾 */
  sts_cfg = get_cfg (cfgname);
  if (sts_cfg != 0)
	{
	  if (sts_cfg == -1)
		{
		  /* 0.40 G[̓bZ[W}~ło͂ */
		  sprintf (wk_ch, "  `t@C(%s)疳(T-T)\n", cfgname);
		  helpdisp (argv[0], wk_ch);
		  exit (-1);
		}
	}

  /* ̧ٵ */
  if ((oldlog = fopen (oldname, "rb")) == NULL)
	{
	  fprintf (stderr, "  ȃt@C悧`(T_T)->[%s]", oldname);
	  exit (1);
	}
  else
	{
#ifdef JACK_PATCH
#ifndef __MSDOS__
#define NEWBUFSIZ 16384
#else
#define NEWBUFSIZ 8192
#endif
	  if (NEWBUFSIZ > BUFSIZ)
		(void) setvbuf (oldlog, NULL, _IOFBF, NEWBUFSIZ);
#endif
	  oldsize = getsize (oldlog);
	  if (disp_mes == TRUE)
		{
		  printf ("  log file(%s) size is %ld bytes\n", oldname, oldsize);
		}
	}

  /* ϊ̧ٵ */
  if ((newlog = fopen (newname, "wb")) == NULL)
	{
	  /* ݎs */
	  fprintf (stderr, "  t@CȂ񂾂悧`(T-T)->[%s]", newname);
	  fclose (oldlog);
	  exit (1);
	}
#ifdef JACK_PATCH
  if (NEWBUFSIZ > BUFSIZ)
	(void) setvbuf (newlog, NULL, _IOFBF, NEWBUFSIZ);
#endif

  open_log = 1;

  /* allocate memory */
  for (i = 0; i < netxfer; i++)
	{							/* 0.30E */
#ifdef JACK_PATCH
	  if ((message_num[i] = CALLOC (mesmax, sizeof (long))) == NULL)
#else
	  if ((message_num[i] = MALLOC (mesmax * sizeof (long))) == NULL)
#endif
		{
		  fprintf (stderr, "  `Ȃ́ABNUMMAXĂ\n");
		  fclose_all ();
		  exit (1);
		}
	}
  /* 0.30E */
#ifdef JACK_PATCH
  if ((ownserial = CALLOC (mesmax, sizeof (long))) == NULL)
#else
  if ((ownserial = MALLOC (mesmax * sizeof (long))) == NULL)
#endif
	{
	  fprintf (stderr, "@Ȃ́ABNUMMAXĂ\n");
	  for (i = 0; i < netxfer; i++)
		{
		  FREE (message_num[i]);
		}
	  fclose_all ();
	  exit (1);
	}
#ifdef JACK_PATCH
  if ((origin_net = CALLOC (mesmax, sizeof (short))) == NULL)
#else
  if ((origin_net = MALLOC (mesmax * sizeof (short))) == NULL)
#endif
	{
	  fprintf (stderr, " ƏȂ́ABNUMMAXĂ\n");
	  FREE (ownserial);
	  for (i = (netxfer - 1); i >= 0; i--)
		{
		  FREE (message_num[i]);
		}
	  fclose_all ();
	  exit (1);
	}

  linknum = 0;
  oldlinknum = 0;
  if ((init_proc (datname)) != 0)
	{
	  fprintf (stderr, "f[^t@C(%s)̓ǂݍ݂Ɏs悧` \n", datname);
	  FREE (origin_net);
	  FREE (ownserial);
	  for (i = (netxfer - 1); i >= 0; i--)
		{
		  FREE (message_num[i]);
		}
	  fclose_all ();
	  exit (1);
	}

  fileend = FALSE;
  messtat = 0;
  tidx = 0;
  /* Ҳݏٰ */
  while (!fileend)
	{
	  readline (oldlog);
	  if (procline ())
		{
		  do
			{
			  strcpy (linesave[tidx], line);
			  tidx++;
			  readline (oldlog);
			}
		  while (procline ()!= 0);
		  /* write saved lines, but last line not write */
		  for (i = 0; i < tidx; i++)
			{
			  fputs (linesave[i], newlog);
			}
		  tidx = 0;
		}
	  fputs ((char *) line, newlog);
	}

  if (disp_mes != TRUE)
	{
	  printf ("\n");
	}

  /* Şٸ۰ */
  fclose_all ();
  open_log = 0;

  /* ̧ٖύX */
  rename (oldname, bakname);
  rename (newname, oldname);

  if ((linkdiff = linknum - oldlinknum) < 0)
	{
	  linkdiff = linkdiff + mesmax;
	}
  printf ("  link num is %hd(link idx %hd to %hd, wrap is %hd)\n", linkdiff,
		  oldlinknum,
		  linknum,
		  wrap
	);
  if (disp_mes == TRUE)
	{
	  printf (" back up File is %s \n", bakname);
	}

  if ((store (datname)) != 0)
	{
	  fprintf (stderr, "f[^t@C(%s)݂̏Ɏs܂\n", datname);
	}

  /* 0.40 */
  exit_free ();

  return (0);
}								/* main() */

void
exit_free ()
{
  short i;
  /* m؂̑S */
  FREE (origin_net);
  FREE (ownserial);
  for (i = (netxfer - 1); i >= 0; i--)
	{
	  FREE (message_num[i]);
	}
}

/* 0.40 */
void
helpdisp (char *name, char *mes)
{
  /* Usage\ */
  fprintf (stderr, "  %s", mes);
  fprintf (stderr, "\n");
  fprintf (stderr, "  Usage:%s [-Fconfigfile -D] logname\n", name);
  fprintf (stderr, "    [-Fconfigfile] : config file name\n");
  fprintf (stderr, "    [-D]           : debug mode\n");
  fprintf (stderr, "    log name       : log file name\n");
  fprintf (stderr, "\n");
}								/* helpdisp() */

/* 0.40 */
void
mod_name (char *nam, char *no_ext, char *ext)
{
  int flg_hit;
  int i;

  /* ̧ٖ쐬 */
  /* ̧ٖ납 */
  flg_hit = 0;
  for (i = (strlen (nam) - 1); i > 0; i--)
	{
	  if (nam[i] == '.')
		{
		  /* صނL炻ȑO̧ٖ(߽) */
		  flg_hit = 1;
		  break;
		}
	  if (nam[i] == '\\')
		{
		  /* gq */
		  break;
		}
	}
  if (flg_hit == 0)
	{
	  /* gq */
	  strcpy (no_ext, nam);
	  strcat (nam, ext);
	}
  else
	{
	  /* gqL */
	  /* ̧ٖ̂ݎo */
	  for (i = 0; i < strlen (nam); i++)
		{
		  if (nam[i] != '.')
			{
			  no_ext[i] = nam[i];
			}
		  else
			{
			  break;
			}
		}
	  no_ext[i] = '\0';
	}
}								/* mod_name() */

short
get_cfg (char *cfgname)
{
  int i;
  int j;
  short sts;
  char wk_ch[256];
  char wk_pam[10];
  FILE *cfgp;					/* `̧ٽذ   *//* 0.30E */

  if (disp_mes == TRUE)
	{
	  printf ("  process cfg file(%s)\n", cfgname);
	}

  /* `̧ٵ 0.40 const to string cfgname */
  if ((cfgp = fopen (cfgname, "rb")) == NULL)
	{
	  return (-1);
	}
  open_cfg = 1;
  sts = 0;
  oldsize = getsize (cfgp);

  while (1)
	{
	  readline (cfgp);
	  if (line[0] == '#')
		{
		  /* 擪 # ͺčs */
		  continue;
		}
	  /* 擪̽߰/޽ */
	  for (i = 0; i < 255; i++)
		{
		  if ((line[i] == '\0') || (line[i] == ';'))
			{					/* 0.40 for GCC */
			  break;
			}
		  if ((line[i] != ' ') && (line[i] != '\t'))
			{
			  break;
			}
		}
	  j = 0;
	  for (; i < 255; i++)
		{
		  if ((line[i] == '\0') || (line[i] == ';'))
			{					/* 0.40 for GCC */
			  break;
			}
		  wk_ch[j] = line[i];
		  j++;
		}
	  wk_ch[j] = '\0';			/* 0.40 for GCC */
	  if (strncmp (wk_ch, "LOGDIR", 6) == 0)
		{
		  /* ۸ُ̧ިڸ(\@\) */
		  continue;
		}
	  else if (strncmp (wk_ch, "BAKDIR", 6) == 0)
		{
		  /* ޯިڸ(\@\) */
		  continue;
		}
	  else if (strncmp (wk_ch, "BASENET", 7) == 0)
		{
		  /* ްȯĖ */
		  if (get_pam (net[0], wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "LINKNET1", 8) == 0)
		{
		  /* ݸȯĖ1 */
		  if (get_pam (net[1], wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "LINKNET2", 8) == 0)
		{
		  /* ݸȯĖ2 */
		  if (get_pam (net[2], wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "LINKNET3", 8) == 0)
		{
		  /* ݸȯĖ3 */
		  if (get_pam (net[3], wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "LINKNET4", 8) == 0)
		{
		  /* ݸȯĖ4 */
		  if (get_pam (net[4], wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "MAXNETNUM", 9) == 0)
		{
		  /* őȯĐ */
		  if (get_pam (wk_pam, wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		  netxfer = atoi (wk_pam);
		  if (netxfer > MAXXFER)
			{
			  fprintf (stderr, "  MESNETNUM is too big, please set below %d\n", MAXXFER);
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "BNUMMAX", 7) == 0)
		{
		  /* үޕۑő吔 */
		  if (get_pam (wk_pam, wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		  mesmax = atoi (wk_pam);
		  if (mesmax > MAXMES)
			{
			  fprintf (stderr, "  MESMAX is too big, please set below %d\n", MAXMES);
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "HEADBORDER1", 11) == 0)
		{
		  /* ͯ */
		  if (get_pam (border1, wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "HEADBORDER2", 11) == 0)
		{
		  /* ڽͯ(ر) */
		  if (get_pam (border2, wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "HEADBORDER3", 11) == 0)
		{
		  /* ڽt */
		  if (get_pam (border3, wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "BLTITLE", 7) == 0)
		{
		  /* ްޖ */
		  if (get_pam (bltitle, wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "XFERTITLE", 9) == 0)
		{
		  /* ݸͯގ */
		  if (get_pam (xfertitle, wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "RESTITLE", 8) == 0)
		{
		  /* ڽͯ */
		  if (get_pam (response, wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "BLINKID", 7) == 0)
		{
		  /* ݸSID */
		  if (get_pam (blinkid, wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "NETHEADER", 9) == 0)
		{
		  /* `(^^; */
		  if (get_pam (net_header, wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		}
	  else if (strncmp (wk_ch, "SHEADNUM", 8) == 0)
		{
		  /* رͯތ */
		  if (get_pam (wk_pam, wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		  shead_num = atoi (wk_pam);
		}
	  else if (strncmp (wk_ch, "LINKID", 6) == 0)
		{
		  /* ݸIDĊJnԍ1`MAXXFER mod 0.40 */
		  i = atoi (&wk_ch[6]);
		  if ((i < 1) || (i > (MAXXFER - 1)))
			{
			  fprintf (stderr, " illigal LINKID ! %d\n", i);
			  sts = -1;
			  break;
			}
		  if (get_pam (wk_pam, wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		  st_no[i - 1] = atol (wk_pam);
		}
	  else if (strncmp (wk_ch, "IDMODFLG", 8) == 0)
		{						/* add 0.40 */
		  /* ȯݸIDĂͯނɎ荞 */
		  if (get_pam (wk_pam, wk_ch) != 0)
			{
			  sts = -1;
			  break;
			}
		  idmod = atoi (wk_pam);
		}
	  if (fileend == TRUE)
		{						/* mod 0.40 */
		  break;
		}
	}
  /* CFĢٸ۰ */
  fclose (cfgp);
  open_cfg = 0;
  if (sts == -1)
	{
	  exit (-1);
	}
  return 0;
}								/* get_cfg() */

short
get_pam (char *dst_str, char *src_str)
{
  int i;
  int j;
  int flg_hit;

  for (i = 0; i < 256; i++)
	{
	  if (src_str[i] == '"')
		{
		  /* " ܂Ž */
		  i++;
		  break;
		}
	}
  flg_hit = 0;
  j = 0;
  for (; i < 256; i++)
	{
	  if (src_str[i] != '"')
		{
		  /*  " ܂ */
		  dst_str[j] = src_str[i];
		  j++;
		}
	  else
		{
		  flg_hit = 1;
		  break;
		}
	}
  if (flg_hit == 0)
	{
	  fprintf (stderr, "`̧قɕss܂ (--; \n");
	  fprintf (stderr, "̍s|||||||| \n");
	  fprintf (stderr, "vvvvvvvvvvvvvvvv \n");
	  fprintf (stderr, "[%s]\n", src_str);
	  return (-1);
	}
  dst_str[j] = '\0';			/* 0.40 for GCC */

#if 0
  printf ("dst_str=[%s]\n", dst_str);
#endif
  return (0);
}								/* get_pam() */

short
init_proc (char *dat)
{
  char magic[8];
  long i, j;
  short wk;
  FILE *fp;

  /* үðُ */
  for (i = 0; i < mesmax; i++)
	{
	  for (j = 0; j < netxfer; j++)
		{
		  message_num[j][i] = -1L;
		}
	}
  if (access (dat, 0) != 0)
	{
#ifndef JACK_PATCH
	  /* ̧ق͖ */
	  fprintf (stderr, "  no dat file(%s) - 1st time\n", dat);
#endif
	  return (0);
	}
  else
	{
	  /* read DAT file */
	  if ((fp = fopen (dat, "rb")) != NULL)
		{
		  fread (&magic, 8, 1, fp);
		  if ((strncmp (magic, "LLC_DATA", 8) != 0))
			{
			  /* ް̧ق̐擪 LLC_DATA ̕񂪖ƴװ */
			  fprintf (stderr, "  ERROR:%s is not dat file\n", dat);
			  fclose (fp);
			  return (-1);
			}
		  fread (&wk, sizeof (short), 1, fp);
		  if (netxfer != wk)
			{
			  fprintf (stderr, "  ERROR:%s netxfer is different to cfg > %hd\n", dat, wk);
			  fclose (fp);
			  return (-1);
			}
		  fread (&wk, sizeof (short), 1, fp);
		  if (mesmax != wk)
			{
			  fprintf (stderr, "  ERROR:%s mesmax is different to cfg > %hd\n", dat, wk);
			  fclose (fp);
			  return (-1);
			}
		  fread (&linknum, sizeof (short), 1, fp);
		  if ((linknum < 0) || (linknum > mesmax))
			{
			  fprintf (stderr, "  ERROR:%s illigal linknum value %hd\n", dat, linknum);
			  fclose (fp);
			  return (-1);
			}
		  oldlinknum = linknum;
		  fread (&wrap, sizeof (short), 1, fp);
		  if ((wrap < 0) || (wrap > 1))
			{
			  fprintf (stderr, "  ERROR:%s illigal wrap value %hd\n", dat, wrap);
			  fclose (fp);
			  return (-1);
			}
		  if ((readdat (fp, (char FAR *) ownserial, (mesmax * sizeof (long)))) != 0)
			{
			  fprintf (stderr, "  ERROR:%s read ownserial data \n", dat);
			  fclose (fp);
			  return (-1);
			}
		  for (i = 0; i < netxfer; i++)
			{
			  if ((readdat (fp, (char FAR *) message_num[i], (mesmax * sizeof (long)))) != 0)
				{
#ifdef JACK_PATCH
				  fprintf (stderr, "  ERROR:%s read messgae_num[%ld]\n", dat, i);
#else
				  fprintf (stderr, "  ERROR:%s read messgae_num[%ld]\n", i, dat);
#endif
				  fclose (fp);
				  return (-1);
				}
			}
		  if ((readdat (fp, (char FAR *) origin_net, (mesmax * sizeof (short)))) != 0)
			{
			  fprintf (stderr, "  ERROR:%s read origin_net data\n", dat);
			  fclose (fp);
			  return (-1);
			}
		  fclose (fp);
		}
	  else
		{
		  /* ݎs */
		  fprintf (stderr, "  unbelivable! file open error %s\n", dat);
		  return (-1);
		}
	}
  return (0);
}								/* init() */

short
store (char *dat)
{
  long i;
  FILE *fp;
  char magic[9] = "LLC_DATA";

  /* read DAT file */
  if ((fp = fopen (dat, "wb")) != NULL)
	{
	  if ((fwrite (&magic, 8, 1, fp)) == 0)
		{
		  fprintf (stderr, "  ERROR:%s write magic \n", dat);
		  fclose (fp);
		  return (-1);
		}
	  if ((fwrite (&netxfer, sizeof (short), 1, fp)) == 0)
		{
		  fprintf (stderr, "  ERROR:%s write netxfer \n", dat);
		  fclose (fp);
		  return (-1);
		}
	  if ((fwrite (&mesmax, sizeof (short), 1, fp)) == 0)
		{
		  fprintf (stderr, "  ERROR:%s write mesmax \n", dat);
		  fclose (fp);
		  return (-1);
		}
	  if ((fwrite (&linknum, sizeof (short), 1, fp)) == 0)
		{
		  fprintf (stderr, "  ERROR:%s write linknum \n", dat);
		  fclose (fp);
		  return (-1);
		}
	  if ((fwrite (&wrap, sizeof (short), 1, fp)) == 0)
		{
		  fprintf (stderr, "  ERROR:%s write wrap \n", dat);
		  fclose (fp);
		  return (-1);
		}
	  if ((writedat (fp, (char FAR *) ownserial, (mesmax * sizeof (long)))) != 0)
		{
		  fprintf (stderr, "  ERROR:%s write ownserial data \n", dat);
		  fclose (fp);
		  return (-1);
		}
	  for (i = 0; i < netxfer; i++)
		{
		  if ((writedat (fp, (char FAR *) message_num[i], (mesmax * sizeof (long)))) != 0)
			{
#ifdef JACK_PATCH
			  fprintf (stderr, "  ERROR:%s write messgae_num[%ld]\n", dat, i);
#else
			  fprintf (stderr, "  ERROR:%s write messgae_num[%ld]\n", i, dat);
#endif
			  fclose (fp);
			  return (-1);
			}
		}
	  if ((writedat (fp, (char FAR *) origin_net, (mesmax * sizeof (short)))) != 0)
		{
		  fprintf (stderr, "  ERROR:%s write origin_net data\n", dat);
		  fclose (fp);
		  return (-1);
		}
	  fclose (fp);
	}
  else
	{
	  /* ݎs */
	  fprintf (stderr, "  unbelivable! file open error %s\n", dat);
	  return (-1);
	}
  return (0);
}								/* store() */

short
procline (void)
{
  static long total_line_num = 0L;
  static long mes_line_idx = 0L;
  static long link_mes_idx = 0L;
  static short resp_flag = 0;
  long i;
  short j;
  long mesno;
  long own;
  long shift_id;
  long base_id;
  static unsigned char mesnos1[17];
  static unsigned char get_handle[27];

  shift_id = 0L;
  total_line_num++;
  if (disp_mes != TRUE)
	{
	  if ((total_line_num % 100) == 0)
		{
		  printf ("o");
#ifdef JACK_PATCH
		  fflush (stdout);
#endif
		}
	}
  for (i = 0; i < MAX_TITLE_LINE_LENGTH; i++)
	{
	  if (line[i] == '\0')
		{
		  break;
		}
	}

  /* 0.40 for long line and it is not link data */
  if (i >= (MAX_TITLE_LINE_LENGTH - 1))
	{
#if 0
	  printf ("long line %ld\n", total_line_num);
#endif
	  if (messtat == 6)
		{
		  linknum++;
		  if (linknum >= mesmax)
			{
			  /* үސE𒴂 */
			  wrap = TRUE;
			  if (disp_mes == TRUE)
				{
				  fprintf (stderr, " too many link message %ld %d %d ! wrap\n",
						   total_line_num, linknum, mesmax);
				}
			  linknum = 0;
			}
		}
	  messtat = 0;
	  return (messtat);
	}
  /* wb_̍ŏ(=0)琔es̏ */
  switch (messtat)
	{
	case 0:
	  {
		/* search message headder */
		if (!(strncmp (line, border1, strlen (border1))))
		  {
			/* ͯނ̈sڔ */
			mes_line_idx++;
			/* for no serial header */
			if (shead_num > 0)
			  {
				/* for long serial header */
				for (i = 7; i < (7 + 4 + shead_num); i++)
				  {
					mesnos1[i - 7] = line[i];
				  }
				mesnos1[4 + 1 + shead_num] = 0;
			  }
			else
			  {
				mesnos1[0] = 0;
			  }
			if (!(strncmp (&line[18 + shead_num], border2, strlen (border2))))
			  {
				/* ڽƂı߂ꂽ̂͏Ȃ */
				resp_flag = 1;
			  }
			else
			  {
				resp_flag = 0;
			  }
			if (shead_num > 0)
			  {
				sscanf (&mesnos1[4], "%ld", &own);
				ownserial[linknum] = own;
			  }
			else
			  {
				ownserial[linknum] = 0;
			  }
#if 0
			printf (" found header %ld in line %ld %s\n",
					mes_line_idx, total_line_num, mesnos1);
#endif
			messtat = 1;
		  }
		break;
	  }
	case 1:
	  {
		if (!(strncmp (line, bltitle, strlen (bltitle))))
		  {
			/* ȯݸĂްޖ */
			link_mes_idx++;
			message_num[0][linknum] = getnum (&line[6], '/');
			messtat++;
#if 0
			printf (" found net link header %5ld in line %ld serial %s bd %ld\n",
			link_mes_idx, total_line_num, mesnos1, message_num[0][linknum]);
#endif
		  }
		else
		  {
			/* ȯݸĂȂ */
			messtat = 0;
		  }
		break;
	  }
	case 2:
	  {
		if (shead_num == 0)
		  {
			if (line[1] == '<')
			  {
				resp_flag = 1;
			  }
		  }
		/* ڽłȂ1sȂ */
		if (!resp_flag)
		  {
			messtat++;
		  }
	case 3:
	case 4:
		/* ȯݸ̓]үނ܂œǂݔ΂ */
		messtat++;
		break;
	  }
	case 5:
	case 6:
	  {
		if (!(strncmp (line, xfertitle, strlen (xfertitle))))
		  {
			if (messtat == 5)
			  {
				/* ȯݸ]үނ𔭌(Ps) */
				if (disp_mes == TRUE)
				  {
					printf (" found %5ld xfer mes %5ld in line %5ld serial %010ld\n",
							link_mes_idx, message_num[0][linknum], total_line_num, ownserial[linknum]);
				  }
			  }
			if (!(strncmp (&line[6], response, strlen (response))))
			  {
				/* ڽ */
				i = getnum (&line[10], ':');
				/* ڽ̏񂪂邩 */
				if ((mesno = searchorigin (origin_net[linknum], i)) != -1)
				  {
					/* found original message */
					if (!resp_flag)
					  {
						if (shead_num > 0)
						  {
							/* رͯނ̍s */
							makehead (linesave[0], ownserial[mesno]);
						  }
						/* ͯނ2sڂ3sڂ̊Ԃڽsǉ */
						for (j = tidx; j > 2; j--)
						  {
							strcpy (linesave[j], linesave[j - 1]);
						  }
						tidx++;
						makeres (linesave[2], line, message_num[0][mesno]);
						if (disp_mes == TRUE)
						  {
							printf (" *");		/* modify message */
						  }
					  }
					else
					  {
						if (disp_mes == TRUE)
						  {
							printf ("  ");		/* already modify */
						  }
					  }
					if (disp_mes == TRUE)
					  {
						printf (" response to %s:%ld is %s %ld\n",
								net[origin_net[linknum]],
								i,
								net_header,
								message_num[0][mesno]);
					  }
				  }
				else
				  {
					/* ڽs ̂܂ */
					if (disp_mes == TRUE)
					  {
						printf ("   response to %s:%ld is %s not found\n",
								net[origin_net[linknum]], i, net_header);
					  }
				  }
			  }
			else
			  {
				for (i = 0; i < netxfer; i++)
				  {
					/* ǂȯĂ]Ă */
					if (!(strncmp (&line[6], net[i], strlen (net[i]))))
					  {
						message_num[i][linknum] = getnum (&line[54], ' ');
						if (disp_mes == TRUE)
						  {		/* 0.40 */
							printf ("   from %s(%ld) and local num %ld\n",
									net[i], i, message_num[i][linknum]);
						  }
						/* Ōɂ݂̂̏ȯ */
						origin_net[linknum] = i;
						break;
					  }
				  }
				/* rewrite board link handle */
				/* ق݂̏̐l̂̂ɕύX */
				/* #TĂȍ~̐IDƂĎ擾 */
				/* VͯނH, Vwb_łȂΉȂ */
				if ((line[15] == '#') && (idmod == TRUE))
				  {
					/* Vͯ (ͯނق܂܂) */
					base_id = getnum (&line[16], ':');
					/* ǂȯĂ݂̏𔻒fĂp̼ĔԍZ */
					if ((i >= 1) || (i <= (MAXXFER - 1)))
					  {
						shift_id = st_no[i - 1] + base_id;
					  }
					else
					  {
						/* unknown net ? */
#ifdef JACK_PATCH
						fprintf (stderr, " unknown net %ld\n", i);
#else
						fprintf (stderr, " unknown net %d\n", i);
#endif
						fclose_all ();
						exit_free ();
						exit (1);
					  }
					/* nh擾IDƋɏ */
					sprintf (get_handle, "%ld:%.15s", shift_id, &line[21]);
					*(strchr (linesave[2], 's') + 2) = 0;
					strncat (linesave[2], get_handle, 21);
					strcat (linesave[2], "\r\n");
				  }
			  }
			messtat = 6;
		  }
		else
		  {
			if (messtat == 5)
			  {
				/* ]Ăүނł͂Ȃ */
			  }
			else
			  {
				linknum++;
				if (linknum > mesmax)
				  {
					/* үސE𒴂 0.40 */
					wrap = TRUE;
					fprintf (stderr, " too many link message%d %d ! wrap\n", linknum, mesmax);
					linknum = 0;
				  }
			  }
			messtat = 0;
		  }
		break;
	  }
	default:
	  {
		break;
	  }
	}
  return messtat;
}								/* procline() */

/* TAlɕϊĕԂ */
long
getnum (unsigned char *l1, char sep)
{
  short j;
  long res;						/* 0.04 correct size */
  unsigned char number[6];

  j = 0;
  while (!isdigit (*l1))
	{
	  l1++;
	}
  do
	{
	  number[j] = *l1;
	  l1++;
	  j++;
	  if (j >= 6)
		{
		  break;
		}
	}
#ifdef JACK_PATCH
  while (*l1 != (unsigned char) sep)
	;
#else
  while ((*l1) != sep);
#endif
  number[j] = 0;
  sscanf (number, "%ld", &res);	/* 0.40 */
#if 0
  printf ("string is %s,number is %ld\n", number, res);
#endif
  return res;
}								/* getnum() */

/* ͔CɌүނT */
long
searchorigin (short net, long bnum)
{
  long i;

  /* */
  for (i = (linknum - 1); i >= 0; i--)
	{
	  if (bnum == message_num[net][i])
		{
		  return (i);
		}
	}
  if (wrap == TRUE)
	{							/* 0.40 */
	  for (i = (mesmax - 1); i >= linknum; i--)
		{
		  if (bnum == message_num[net][i])
			{
			  return (i);
			}
		}
	}
  return (-1L);
}								/* searchorigin() */

/* ڽ̼رͯނǉ */
void
makehead (unsigned char *DstBuf, long i)
{
#ifdef JACK_PATCH
  /* lbg[NID(4) + VAԍ(10) + '\0' */
  unsigned char tmpBuf[4 + 10 + 1];
  unsigned char sh_form[sizeof net_header + 10 + 1];
#else
  unsigned char tmpBuf[30];
  unsigned char sh_form[30];
#endif

  /* ŃXwb_쐬ȂȂȂ̂悧`(^^; */
  sprintf (sh_form, "%s%%0%dld", net_header, shead_num);

#if 0
  printf ("sh_form=[%s]\n", sh_form);
#endif

  sprintf (tmpBuf, sh_form, i);
  DstBuf[15 + shead_num] = 0;
  strcat (DstBuf, "3m<");
  strcat (DstBuf, tmpBuf);
  strcat (DstBuf, border3);
  strcat (DstBuf, "\r\n");
}								/* makehead() */

/*
		l1:dest
		l2:src(in linked net)
		bnum:mes num

		if memory available,save message title!
*/
void
makeres (unsigned char *DstBuf, unsigned char *SrcBuf, long bnum)
{
  short i;
  short j;
  short k;
  short l;
  short m;

  i = searchchar (SrcBuf, ':');
  j = i;
  do
	{
	  m = 0;
	  j = searchchar (&SrcBuf[j], '/') + j;
	  k = searchchar (&SrcBuf[j], ':') + j;
	  for (l = (j + 1); l < k; l++)
		{
		  if (!(isdigit (SrcBuf[l])))
			{

			  DstBuf[0] = 0;
			  strncat (DstBuf, &SrcBuf[j], (k - j + 1));
#if 0
			  printf ("heavy title! %d %d > %s\n", j, k, DstBuf);
#endif
			  j++;
			  m = 1;
			  break;
			}
		}
	}
  while (m == 1);

  sprintf (DstBuf, " <%ld", bnum);
  strncat (DstBuf, &SrcBuf[i], (j - i + 1));
  strcat (DstBuf, blinkid);
  strcat (DstBuf, &SrcBuf[k]);
}								/* makeres() */

short
searchchar (unsigned char *SrcBuf, char sep)
{
  short i;
  short j;

  i = 0;
  j = strlen (SrcBuf);
#ifdef JACK_PATCH
  while (*SrcBuf != (unsigned char) sep)
#else
  while ((*SrcBuf) != sep)
#endif
	{
	  i++;
	  SrcBuf++;
	  if (i >= j)
		{
		  break;
		}
	}
  return i;
}								/* searchchar() */

short
readdat (FILE * fp, char FAR * buff, unsigned sizes)
{
  int readsize;

  while (sizes > 0)
	{
	  if (sizes > READ_BUFFER_SIZE)
		{
		  if ((readsize = fread (readbuff, READ_BUFFER_SIZE, 1, fp)) == 0)
			{
			  return (-1);
			}
		  MEMCPY2F (buff, readbuff, READ_BUFFER_SIZE);
		  buff = buff + (long) READ_BUFFER_SIZE;
		  sizes = sizes - READ_BUFFER_SIZE;
		}
	  else
		{
		  if ((readsize = fread (readbuff, sizes, 1, fp)) == 0)
			{
			  return (-1);
			}
		  MEMCPY2F (buff, readbuff, sizes);
		  buff = buff + (long) sizes;
		  sizes = 0;
		}
	}
  return 0;
}								/* readdat() */

short
writedat (FILE * fp, char FAR * buff, unsigned sizes)
{
  int writesize;

  while (sizes > 0)
	{
	  if (sizes > READ_BUFFER_SIZE)
		{
		  MEMCPY2N (readbuff, buff, READ_BUFFER_SIZE);
		  buff = buff + (long) READ_BUFFER_SIZE;
		  if ((writesize = fwrite (readbuff, READ_BUFFER_SIZE, 1, fp)) == 0)
			{
			  return (-1);
			}
		  sizes = sizes - READ_BUFFER_SIZE;
		}
	  else
		{
		  MEMCPY2N (readbuff, buff, sizes);
		  buff = buff + (long) sizes;
		  if ((writesize = fwrite (readbuff, sizes, 1, fp)) == 0)
			{
			  return (-1);
			}
		  sizes = 0;
		}
	}
  return 0;
}								/* readdat() */

void
readline (FILE * fp)
{
  long i;
  unsigned char c;
  unsigned char c1 = 0;

  line[0] = 0;
  i = 0;
  while (((c = readchar (fp)) != EOL) && (c1 != EOL0))
	{
	  if (fileend == TRUE)
		{
		  break;
		}
	  line[i] = c;
	  i++;
	  if (i >= MAX_LINE_LENGTH)
		{						/* 0.40 check bus error */
		  fprintf (stderr, " why ? too long line, over %d\n", MAX_LINE_LENGTH);
		  if (open_cfg == 1)
			{
			  fclose (fp);
			}
		  if (open_log == 1)
			{
			  fclose_all ();
			  exit_free ();
			}
		  exit (1);
		}
	  c1 = c;
	}
  line[i] = c;
  i++;
  line[i] = 0;
}								/* readline() */

unsigned char
readchar (FILE * fp)
{
  static long buffidx = 0;
  static long buffremain = 0;

  buffidx++;
  if (buffremain == 0)
	{
	  buffremain = fread (readbuff, 1, READ_BUFFER_SIZE, fp);
#if 0
	  printf ("read size is %d\n", buffremain);
#endif
	  oldsize = (oldsize - buffremain);
	  buffidx = 0;
	}
  buffremain--;
  if ((oldsize == 0) && (buffremain == 0))
	{
	  fileend = TRUE;
	}
  return readbuff[buffidx];
}								/* readchar() */

long
getsize (FILE * fp)
{
  long i;

  fseek (fp, 0, SEEK_END);		/* 0.40 for GCC */
  i = ftell (fp);
  fseek (fp, 0, SEEK_SET);
  return (i);
}								/* getsize() */

void
fclose_all (void)
{
  if (open_log == 1)
	{
	  fclose (oldlog);
	  fclose (newlog);
	}
}

#ifndef JACK_PATCH
#if __LSIC__
int 
_nullcheck (void)
{
  return (0);
}

#endif
#endif /* JACK_PATCH */
